
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class HashtagsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const hashtags = await db.hashtags.create(
            {
                id: data.id || undefined,
        
        tag: data.tag
        ||
        null
            ,
            
        is_blocked: data.is_blocked
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return hashtags;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const hashtagsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                tag: item.tag
            ||
            null
            ,
            
                is_blocked: item.is_blocked
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const hashtags = await db.hashtags.bulkCreate(hashtagsData, { transaction });

        // For each item created, replace relation files
        

        return hashtags;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const hashtags = await db.hashtags.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.tag !== undefined) updatePayload.tag = data.tag;
        
        
        if (data.is_blocked !== undefined) updatePayload.is_blocked = data.is_blocked;
        
        
        updatePayload.updatedById = currentUser.id;

        await hashtags.update(updatePayload, {transaction});

        
        

        
        

        

        return hashtags;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const hashtags = await db.hashtags.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of hashtags) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of hashtags) {
                await record.destroy({transaction});
            }
        });


        return hashtags;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const hashtags = await db.hashtags.findByPk(id, options);

        await hashtags.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await hashtags.destroy({
            transaction
        });

        return hashtags;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const hashtags = await db.hashtags.findOne(
            { where },
            { transaction },
        );

        if (!hashtags) {
            return hashtags;
        }

        const output = hashtags.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.post_hashtags_hashtag = await hashtags.getPost_hashtags_hashtag({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.tag) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'hashtags',
                        'tag',
                        filter.tag,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_blocked) {
                where = {
                    ...where,
                is_blocked: filter.is_blocked,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.hashtags.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'hashtags',
                        'tag',
                        query,
                    ),
                ],
            };
        }

        const records = await db.hashtags.findAll({
            attributes: [ 'id', 'tag' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['tag', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.tag,
        }));
    }

    
};

